[![Documentation Status](https://readthedocs.org/projects/dynamicgem/badge/?version=latest)](https://dynamicgem.readthedocs.io/en/latest/?badge=latest) [![Build Status](https://travis-ci.org/Sujit-O/dynamicgem.svg?branch=master)](https://travis-ci.org/Sujit-O/dynamicgem) [![Coverage Status](https://coveralls.io/repos/github/Sujit-O/dynamicgem/badge.svg?branch=master)](https://coveralls.io/github/Sujit-O/dynamicgem?branch=master) [![PyPI version](https://badge.fury.io/py/dynamicgem.svg)](https://badge.fury.io/py/dynamicgem) [![GitHub license](https://img.shields.io/github/license/Naereen/StrapDown.js.svg)](https://github.com/Naereen/StrapDown.js/blob/master/LICENSE) [![Python 3.6](https://img.shields.io/badge/python-3.6-blue.svg)](https://www.python.org/downloads/release/python-360/) [![CircleCI](https://circleci.com/gh/Sujit-O/dynamicgem.svg?style=svg)](https://circleci.com/gh/Sujit-O/dynamicgem) [![Twitter](https://img.shields.io/twitter/url/https/github.com/Sujit-O/dynamicgem?style=social)](https://twitter.com/intent/tweet?text=Wow:&url=https%3A%2F%2Fgithub.com%2FSujit-O%2Fdynamicgem) 

# dynamicgem

[**Library Documentation**](https://dynamicgem.readthedocs.io)

Graph embedding methods aim to represent each node of a graph in a low-dimensional vector space while preserving certain graph's properties. Such  methods  have been used to tackle many real-world tasks, e.g.,  friend recommendation in social networks, genome classification in biology networks, and visualizing topics in research using collaboration networks.

More recently, much attention has been devoted to extending static embedding techniques to capture graph evolution. Applications include  temporal link prediction, and understanding the evolution dynamics of network communities. Most methods aim to efficiently update the embedding of the graph at each time step using information from previous embedding and from changes in the graph. Some methods also capture the temporal patterns of the evolution in the learned embedding, leading to improved link prediction performance.

In this library, we present an easy-to-use toolkit of state-of-the-art dynamic graph embedding  methods.  **dynamicgem** implements methods which can handle the evolution of networks over time. Further, we provide a comprehensive framework to evaluate the methods by providing support for four tasks on dynamic networks: graph reconstruction, static and temporal link prediction, node classification, and temporal visualization. For each task, our framework includes multiple evaluation metrics to quantify the performance of the methods. We further share synthetic and real networks for evaluation. Thus, our library is an end-to-end framework to experiment with dynamic graph embedding. 
